diff --git a/src/H5Eterm.h b/src/H5Eterm.h
index 9684c29ce1..09f47c9a24 100644
--- a/src/H5Eterm.h
+++ b/src/H5Eterm.h
@@ -19,89 +19,45 @@
 
 /* Reset major error IDs */
     
-H5E_FUNC_g=    
-H5E_FILE_g=    
-H5E_SOHM_g=    
-H5E_SYM_g=    
-H5E_PLUGIN_g=    
 H5E_VFL_g=    
-H5E_INTERNAL_g=    
-H5E_BTREE_g=    
-H5E_REFERENCE_g=    
-H5E_DATASPACE_g=    
-H5E_RESOURCE_g=    
-H5E_RS_g=    
-H5E_FARRAY_g=    
-H5E_HEAP_g=    
-H5E_ATTR_g=    
-H5E_IO_g=    
-H5E_EFL_g=    
+H5E_CACHE_g=    
+H5E_OHDR_g=    
+H5E_SLIST_g=    
 H5E_TST_g=    
+H5E_STORAGE_g=    
 H5E_PAGEBUF_g=    
+H5E_SOHM_g=    
+H5E_SYM_g=    
+H5E_PLIST_g=    
+H5E_IO_g=    
 H5E_FSPACE_g=    
+H5E_FILE_g=    
+H5E_ATTR_g=    
+H5E_REFERENCE_g=    
+H5E_INTERNAL_g=    
 H5E_DATASET_g=    
-H5E_STORAGE_g=    
-H5E_LINK_g=    
-H5E_PLIST_g=    
-H5E_DATATYPE_g=    
-H5E_OHDR_g=    
-H5E_ATOM_g=    
-H5E_NONE_MAJOR_g=    
-H5E_SLIST_g=    
+H5E_EARRAY_g=    
 H5E_ARGS_g=    
 H5E_CONTEXT_g=    
-H5E_EARRAY_g=    
+H5E_PLUGIN_g=    
+H5E_LINK_g=    
 H5E_PLINE_g=    
-H5E_ERROR_g=    
-H5E_CACHE_g= (-1);
+H5E_DATATYPE_g=    
+H5E_FUNC_g=    
+H5E_RS_g=    
+H5E_DATASPACE_g=    
+H5E_EFL_g=    
+H5E_RESOURCE_g=    
+H5E_HEAP_g=    
+H5E_BTREE_g=    
+H5E_NONE_MAJOR_g=    
+H5E_ATOM_g=    
+H5E_FARRAY_g=    
+H5E_ERROR_g= (-1);
 
 /* Reset minor error IDs */
 
 
-/* Generic low-level file I/O errors */    
-H5E_SEEKERROR_g=    
-H5E_READERROR_g=    
-H5E_WRITEERROR_g=    
-H5E_CLOSEERROR_g=    
-H5E_OVERFLOW_g=    
-H5E_FCNTL_g=
-
-/* Resource errors */    
-H5E_NOSPACE_g=    
-H5E_CANTALLOC_g=    
-H5E_CANTCOPY_g=    
-H5E_CANTFREE_g=    
-H5E_ALREADYEXISTS_g=    
-H5E_CANTLOCK_g=    
-H5E_CANTUNLOCK_g=    
-H5E_CANTGC_g=    
-H5E_CANTGETSIZE_g=    
-H5E_OBJOPEN_g=
-
-/* Heap errors */    
-H5E_CANTRESTORE_g=    
-H5E_CANTCOMPUTE_g=    
-H5E_CANTEXTEND_g=    
-H5E_CANTATTACH_g=    
-H5E_CANTUPDATE_g=    
-H5E_CANTOPERATE_g=
-
-/* Function entry/exit interface errors */    
-H5E_CANTINIT_g=    
-H5E_ALREADYINIT_g=    
-H5E_CANTRELEASE_g=
-
-/* Property list errors */    
-H5E_CANTGET_g=    
-H5E_CANTSET_g=    
-H5E_DUPCLASS_g=    
-H5E_SETDISALLOWED_g=
-
-/* Free space errors */    
-H5E_CANTMERGE_g=    
-H5E_CANTREVIVE_g=    
-H5E_CANTSHRINK_g=
-
 /* Object header related errors */    
 H5E_LINKCOUNT_g=    
 H5E_VERSION_g=    
@@ -113,50 +69,18 @@ H5E_CANTPACK_g=
 H5E_CANTRESET_g=    
 H5E_CANTRENAME_g=
 
-/* System level errors */    
-H5E_SYSERRSTR_g=
-
-/* I/O pipeline errors */    
-H5E_NOFILTER_g=    
-H5E_CALLBACK_g=    
-H5E_CANAPPLY_g=    
-H5E_SETLOCAL_g=    
-H5E_NOENCODER_g=    
-H5E_CANTFILTER_g=
-
 /* Group related errors */    
 H5E_CANTOPENOBJ_g=    
 H5E_CANTCLOSEOBJ_g=    
 H5E_COMPLEN_g=    
 H5E_PATH_g=
 
-/* No error */    
-H5E_NONE_MINOR_g=
+/* System level errors */    
+H5E_SYSERRSTR_g=
 
 /* Plugin errors */    
 H5E_OPENERROR_g=
 
-/* File accessibility errors */    
-H5E_FILEEXISTS_g=    
-H5E_FILEOPEN_g=    
-H5E_CANTCREATE_g=    
-H5E_CANTOPENFILE_g=    
-H5E_CANTCLOSEFILE_g=    
-H5E_NOTHDF5_g=    
-H5E_BADFILE_g=    
-H5E_TRUNCATED_g=    
-H5E_MOUNT_g=    
-H5E_CANTLOCKFILE_g=    
-H5E_CANTUNLOCKFILE_g=
-
-/* Object atom related errors */    
-H5E_BADATOM_g=    
-H5E_BADGROUP_g=    
-H5E_CANTREGISTER_g=    
-H5E_CANTINC_g=    
-H5E_CANTDEC_g=    
-H5E_NOIDS_g=
-
 /* Cache related errors */    
 H5E_CANTFLUSH_g=    
 H5E_CANTUNSERIALIZE_g=    
@@ -187,6 +111,22 @@ H5E_LOGFAIL_g=
 H5E_CANTCORK_g=    
 H5E_CANTUNCORK_g=
 
+/* I/O pipeline errors */    
+H5E_NOFILTER_g=    
+H5E_CALLBACK_g=    
+H5E_CANAPPLY_g=    
+H5E_SETLOCAL_g=    
+H5E_NOENCODER_g=    
+H5E_CANTFILTER_g=
+
+/* Generic low-level file I/O errors */    
+H5E_SEEKERROR_g=    
+H5E_READERROR_g=    
+H5E_WRITEERROR_g=    
+H5E_CLOSEERROR_g=    
+H5E_OVERFLOW_g=    
+H5E_FCNTL_g=
+
 /* Link related errors */    
 H5E_TRAVERSE_g=    
 H5E_NLINKS_g=    
@@ -194,12 +134,18 @@ H5E_NOTREGISTERED_g=
 H5E_CANTMOVE_g=    
 H5E_CANTSORT_g=
 
-/* Parallel MPI errors */    
-H5E_MPI_g=    
-H5E_MPIERRSTR_g=    
-H5E_CANTRECV_g=    
-H5E_CANTGATHER_g=    
-H5E_NO_INDEPENDENT_g=
+/* File accessibility errors */    
+H5E_FILEEXISTS_g=    
+H5E_FILEOPEN_g=    
+H5E_CANTCREATE_g=    
+H5E_CANTOPENFILE_g=    
+H5E_CANTCLOSEFILE_g=    
+H5E_NOTHDF5_g=    
+H5E_BADFILE_g=    
+H5E_TRUNCATED_g=    
+H5E_MOUNT_g=    
+H5E_CANTLOCKFILE_g=    
+H5E_CANTUNLOCKFILE_g=
 
 /* Dataspace errors */    
 H5E_CANTCLIP_g=    
@@ -211,6 +157,11 @@ H5E_CANTCOMPARE_g=
 H5E_INCONSISTENTSTATE_g=    
 H5E_CANTAPPEND_g=
 
+/* Free space errors */    
+H5E_CANTMERGE_g=    
+H5E_CANTREVIVE_g=    
+H5E_CANTSHRINK_g=
+
 /* Argument errors */    
 H5E_UNINITIALIZED_g=    
 H5E_UNSUPPORTED_g=    
@@ -218,6 +169,21 @@ H5E_BADTYPE_g=
 H5E_BADRANGE_g=    
 H5E_BADVALUE_g=
 
+/* Heap errors */    
+H5E_CANTRESTORE_g=    
+H5E_CANTCOMPUTE_g=    
+H5E_CANTEXTEND_g=    
+H5E_CANTATTACH_g=    
+H5E_CANTUPDATE_g=    
+H5E_CANTOPERATE_g=
+
+/* Parallel MPI errors */    
+H5E_MPI_g=    
+H5E_MPIERRSTR_g=    
+H5E_CANTRECV_g=    
+H5E_CANTGATHER_g=    
+H5E_NO_INDEPENDENT_g=
+
 /* B-tree related errors */    
 H5E_NOTFOUND_g=    
 H5E_EXISTS_g=    
@@ -229,10 +195,45 @@ H5E_CANTSWAP_g=
 H5E_CANTINSERT_g=    
 H5E_CANTLIST_g=    
 H5E_CANTMODIFY_g=    
-H5E_CANTREMOVE_g=
+H5E_CANTREMOVE_g=    
+H5E_CANTFIND_g=
+
+/* Property list errors */    
+H5E_CANTGET_g=    
+H5E_CANTSET_g=    
+H5E_DUPCLASS_g=    
+H5E_SETDISALLOWED_g=
+
+/* Resource errors */    
+H5E_NOSPACE_g=    
+H5E_CANTALLOC_g=    
+H5E_CANTCOPY_g=    
+H5E_CANTFREE_g=    
+H5E_ALREADYEXISTS_g=    
+H5E_CANTLOCK_g=    
+H5E_CANTUNLOCK_g=    
+H5E_CANTGC_g=    
+H5E_CANTGETSIZE_g=    
+H5E_OBJOPEN_g=
+
+/* Function entry/exit interface errors */    
+H5E_CANTINIT_g=    
+H5E_ALREADYINIT_g=    
+H5E_CANTRELEASE_g=
 
 /* Datatype conversion errors */    
 H5E_CANTCONVERT_g=    
-H5E_BADSIZE_g= (-1);
+H5E_BADSIZE_g=
+
+/* No error */    
+H5E_NONE_MINOR_g=
+
+/* Object atom related errors */    
+H5E_BADATOM_g=    
+H5E_BADGROUP_g=    
+H5E_CANTREGISTER_g=    
+H5E_CANTINC_g=    
+H5E_CANTDEC_g=    
+H5E_NOIDS_g= (-1);
 
 #endif /* H5Eterm_H */
diff --git a/src/H5Gent.c b/src/H5Gent.c
index feaf9f9cf5..a2a94bffde 100644
--- a/src/H5Gent.c
+++ b/src/H5Gent.c
@@ -354,143 +354,6 @@ H5G__ent_reset(H5G_entry_t *ent)
     FUNC_LEAVE_NOAPI_VOID
 } /* end H5G__ent_reset() */
 
-/*-------------------------------------------------------------------------
- * Function:    H5G__ent_convert
- *
- * Purpose:     Convert a link to a symbol table entry
- *
- * Return:	Success:	Non-negative
- *		Failure:	Negative
- *
- * Programmer:  Quincey Koziol
- *              Sep 20 2005
- *
- *-------------------------------------------------------------------------
- */
-herr_t
-H5G__ent_convert(H5F_t *f, H5HL_t *heap, const char *name, const H5O_link_t *lnk, H5O_type_t obj_type,
-                 const void *crt_info, H5G_entry_t *ent)
-{
-    size_t name_offset;         /* Offset of name in heap */
-    herr_t ret_value = SUCCEED; /* Return value */
-
-    FUNC_ENTER_PACKAGE
-
-    /* check arguments */
-    HDassert(f);
-    HDassert(heap);
-    HDassert(name);
-    HDassert(lnk);
-
-    /* Reset the new entry */
-    H5G__ent_reset(ent);
-
-    /* Add the new name to the heap */
-    if (H5HL_insert(f, heap, HDstrlen(name) + 1, name, &name_offset) < 0)
-        HGOTO_ERROR(H5E_SYM, H5E_CANTINSERT, FAIL, "unable to insert symbol name into heap")
-    ent->name_off = name_offset;
-
-    /* Build correct information for symbol table entry based on link type */
-    switch (lnk->type) {
-        case H5L_TYPE_HARD:
-            if (obj_type == H5O_TYPE_GROUP) {
-                const H5G_obj_create_t *gcrt_info = (const H5G_obj_create_t *)crt_info;
-
-                ent->type = gcrt_info->cache_type;
-                if (ent->type != H5G_NOTHING_CACHED)
-                    ent->cache = gcrt_info->cache;
-#ifndef NDEBUG
-                else {
-                    /* Make sure there is no stab message in the target object
-                     */
-                    H5O_loc_t targ_oloc;   /* Location of link target */
-                    htri_t    stab_exists; /* Whether the target symbol table exists */
-
-                    /* Build target object location */
-                    if (H5O_loc_reset(&targ_oloc) < 0)
-                        HGOTO_ERROR(H5E_SYM, H5E_CANTRESET, FAIL, "unable to initialize target location")
-                    targ_oloc.file = f;
-                    targ_oloc.addr = lnk->u.hard.addr;
-
-                    /* Check if a symbol table message exists */
-                    if ((stab_exists = H5O_msg_exists(&targ_oloc, H5O_STAB_ID)) < 0)
-                        HGOTO_ERROR(H5E_SYM, H5E_NOTFOUND, FAIL, "unable to check for STAB message")
-
-                    HDassert(!stab_exists);
-                } /* end else */
-#endif            /* NDEBUG */
-            }     /* end if */
-            else if (obj_type == H5O_TYPE_UNKNOWN) {
-                /* Try to retrieve symbol table information for caching */
-                H5O_loc_t  targ_oloc;   /* Location of link target */
-                H5O_t     *oh;          /* Link target object header */
-                H5O_stab_t stab;        /* Link target symbol table */
-                htri_t     stab_exists; /* Whether the target symbol table exists */
-
-                /* Build target object location */
-                if (H5O_loc_reset(&targ_oloc) < 0)
-                    HGOTO_ERROR(H5E_SYM, H5E_CANTRESET, FAIL, "unable to initialize target location")
-                targ_oloc.file = f;
-                targ_oloc.addr = lnk->u.hard.addr;
-
-                /* Get the object header */
-                if (NULL == (oh = H5O_protect(&targ_oloc, H5AC__READ_ONLY_FLAG, FALSE)))
-                    HGOTO_ERROR(H5E_SYM, H5E_CANTPROTECT, FAIL, "unable to protect target object header")
-
-                /* Check if a symbol table message exists */
-                if ((stab_exists = H5O_msg_exists_oh(oh, H5O_STAB_ID)) < 0) {
-                    if (H5O_unprotect(&targ_oloc, oh, H5AC__NO_FLAGS_SET) < 0)
-                        HERROR(H5E_SYM, H5E_CANTUNPROTECT, "unable to release object header");
-                    HGOTO_ERROR(H5E_SYM, H5E_NOTFOUND, FAIL, "unable to check for STAB message")
-                } /* end if */
-
-                if (stab_exists) {
-                    /* Read symbol table message */
-                    if (NULL == H5O_msg_read_oh(f, oh, H5O_STAB_ID, &stab)) {
-                        if (H5O_unprotect(&targ_oloc, oh, H5AC__NO_FLAGS_SET) < 0)
-                            HERROR(H5E_SYM, H5E_CANTUNPROTECT, "unable to release object header");
-                        HGOTO_ERROR(H5E_SYM, H5E_CANTGET, FAIL, "unable to read STAB message")
-                    } /* end if */
-
-                    /* Cache symbol table message */
-                    ent->type                  = H5G_CACHED_STAB;
-                    ent->cache.stab.btree_addr = stab.btree_addr;
-                    ent->cache.stab.heap_addr  = stab.heap_addr;
-                } /* end if */
-                else
-                    /* No symbol table message, don't cache anything */
-                    ent->type = H5G_NOTHING_CACHED;
-
-                if (H5O_unprotect(&targ_oloc, oh, H5AC__NO_FLAGS_SET) < 0)
-                    HGOTO_ERROR(H5E_SYM, H5E_CANTUNPROTECT, FAIL, "unable to release object header")
-            } /* end else */
-            else
-                ent->type = H5G_NOTHING_CACHED;
-
-            ent->header = lnk->u.hard.addr;
-            break;
-
-        case H5L_TYPE_SOFT: {
-            size_t lnk_offset; /* Offset to sym-link value	*/
-
-            /* Insert link value into local heap */
-            if (H5HL_insert(f, heap, HDstrlen(lnk->u.soft.name) + 1, lnk->u.soft.name, &lnk_offset) < 0)
-                HGOTO_ERROR(H5E_SYM, H5E_CANTINIT, FAIL, "unable to write link value to local heap")
-
-            ent->type                    = H5G_CACHED_SLINK;
-            ent->cache.slink.lval_offset = lnk_offset;
-        } break;
-
-        case H5L_TYPE_ERROR:
-        case H5L_TYPE_EXTERNAL:
-        case H5L_TYPE_MAX:
-        default:
-            HGOTO_ERROR(H5E_SYM, H5E_BADVALUE, FAIL, "unrecognized link type")
-    } /* end switch */
-
-done:
-    FUNC_LEAVE_NOAPI(ret_value)
-} /* end H5G__ent_convert() */
 
 /*-------------------------------------------------------------------------
  * Function:    H5G__ent_debug
@@ -562,3 +425,76 @@ H5G__ent_debug(const H5G_entry_t *ent, FILE *stream, int indent, int fwidth, con
 
     FUNC_LEAVE_NOAPI(SUCCEED)
 } /* end H5G__ent_debug() */
+
+/*-------------------------------------------------------------------------
+ * Function:    H5G__ent_to_link
+ *
+ * Purpose:     Convert a symbol table entry to a link
+ *
+ * Return:      Non-negative on success/Negative on failure
+ *
+ *-------------------------------------------------------------------------
+ */
+herr_t
+H5G__ent_to_link(const H5G_entry_t *ent, const H5HL_t *heap, H5O_link_t *lnk)
+{
+    const char *name;                /* Pointer to link name in heap */
+    size_t      block_size;          /* Size of the heap block */
+    bool        dup_soft  = false;   /* xstrdup the symbolic link name or not */
+    herr_t      ret_value = SUCCEED; /* Return value */
+
+    FUNC_ENTER_PACKAGE
+
+    /* check arguments */
+    assert(ent);
+    assert(heap);
+    assert(lnk);
+
+    /* Get the size of the heap block */
+    block_size = H5HL_heap_get_size(heap);
+
+    /* Get pointer to link's name in the heap */
+    if (NULL == (name = (const char *)H5HL_offset_into(heap, ent->name_off)))
+        HGOTO_ERROR(H5E_SYM, H5E_CANTGET, FAIL, "unable to get symbol table link name");
+
+    /* Set (default) common info for link */
+    lnk->cset         = H5F_DEFAULT_CSET;
+    lnk->corder       = 0;
+    lnk->corder_valid = false; /* Creation order not valid for this link */
+    if (NULL == (lnk->name = H5MM_strndup(name, (block_size - ent->name_off))))
+        HGOTO_ERROR(H5E_SYM, H5E_CANTGET, FAIL, "unable to duplicate link name");
+
+    /* Object is a symbolic or hard link */
+    if (ent->type == H5G_CACHED_SLINK) {
+        const char *s; /* Pointer to link value */
+
+        if (NULL == (s = (const char *)H5HL_offset_into(heap, ent->cache.slink.lval_offset)))
+            HGOTO_ERROR(H5E_SYM, H5E_CANTGET, FAIL, "unable to get symbolic link name");
+
+        /* Copy the link value */
+        if (NULL == (lnk->u.soft.name = H5MM_strndup(s, (block_size - ent->cache.slink.lval_offset))))
+            HGOTO_ERROR(H5E_SYM, H5E_CANTGET, FAIL, "unable to duplicate symbolic link name");
+
+        dup_soft = true;
+
+        /* Set link type */
+        lnk->type = H5L_TYPE_SOFT;
+    } /* end if */
+    else {
+        /* Set address of object */
+        lnk->u.hard.addr = ent->header;
+
+        /* Set link type */
+        lnk->type = H5L_TYPE_HARD;
+    } /* end else */
+
+done:
+    if (ret_value < 0) {
+        if (lnk->name)
+            H5MM_xfree(lnk->name);
+        if (ent->type == H5G_CACHED_SLINK && dup_soft)
+            H5MM_xfree(lnk->u.soft.name);
+    }
+
+    FUNC_LEAVE_NOAPI(ret_value)
+} /* end H5G__ent_to_link() */
diff --git a/src/H5Glink.c b/src/H5Glink.c
index cd01bc986d..87b909017a 100644
--- a/src/H5Glink.c
+++ b/src/H5Glink.c
@@ -188,72 +188,6 @@ H5G_link_cmp_corder_dec(const void *lnk1, const void *lnk2)
     FUNC_LEAVE_NOAPI(ret_value)
 } /* end H5G_link_cmp_corder_dec() */
 
-/*-------------------------------------------------------------------------
- * Function:	H5G__ent_to_link
- *
- * Purpose:     Convert a symbol table entry to a link
- *
- * Return:	Non-negative on success/Negative on failure
- *
- * Programmer:	Quincey Koziol
- *		Sep 16 2006
- *
- *-------------------------------------------------------------------------
- */
-herr_t
-H5G__ent_to_link(H5O_link_t *lnk, const H5HL_t *heap, const H5G_entry_t *ent, const char *name)
-{
-    hbool_t dup_soft  = FALSE;   /* xstrdup the symbolic link name or not */
-    herr_t  ret_value = SUCCEED; /* Return value */
-
-    FUNC_ENTER_PACKAGE
-
-    /* check arguments */
-    HDassert(lnk);
-    HDassert(heap);
-    HDassert(ent);
-    HDassert(name);
-
-    /* Set (default) common info for link */
-    lnk->cset         = H5F_DEFAULT_CSET;
-    lnk->corder       = 0;
-    lnk->corder_valid = FALSE; /* Creation order not valid for this link */
-    if ((lnk->name = H5MM_xstrdup(name)) == NULL)
-        HGOTO_ERROR(H5E_LINK, H5E_CANTGET, FAIL, "unable to duplicate link name")
-
-    /* Object is a symbolic or hard link */
-    if (ent->type == H5G_CACHED_SLINK) {
-        const char *s; /* Pointer to link value */
-
-        if ((s = (const char *)H5HL_offset_into(heap, ent->cache.slink.lval_offset)) == NULL)
-            HGOTO_ERROR(H5E_LINK, H5E_CANTGET, FAIL, "unable to get symbolic link name")
-
-        /* Copy the link value */
-        if ((lnk->u.soft.name = H5MM_xstrdup(s)) == NULL)
-            HGOTO_ERROR(H5E_LINK, H5E_CANTGET, FAIL, "unable to duplicate symbolic link name")
-
-        dup_soft = TRUE;
-
-        /* Set link type */
-        lnk->type = H5L_TYPE_SOFT;
-    } /* end if */
-    else {
-        /* Set address of object */
-        lnk->u.hard.addr = ent->header;
-
-        /* Set link type */
-        lnk->type = H5L_TYPE_HARD;
-    } /* end else */
-
-done:
-    if (ret_value < 0) {
-        if (lnk->name)
-            H5MM_xfree(lnk->name);
-        if (ent->type == H5G_CACHED_SLINK && dup_soft)
-            H5MM_xfree(lnk->u.soft.name);
-    }
-    FUNC_LEAVE_NOAPI(ret_value)
-} /* end H5G__ent_to_link() */
 
 /*-------------------------------------------------------------------------
  * Function:	H5G_link_to_info
@@ -332,6 +266,140 @@ done:
     FUNC_LEAVE_NOAPI(ret_value)
 } /* end H5G_link_to_info() */
 
+/*-------------------------------------------------------------------------
+ * Function:    H5G__link_to_ent
+ *
+ * Purpose:     Convert a link to a symbol table entry
+ *
+ * Return:	Success:	Non-negative
+ *		Failure:	Negative
+ *
+ *-------------------------------------------------------------------------
+ */
+herr_t
+H5G__link_to_ent(H5F_t *f, H5HL_t *heap, const H5O_link_t *lnk, H5O_type_t obj_type, const void *crt_info,
+                 H5G_entry_t *ent)
+{
+    size_t name_offset;         /* Offset of name in heap */
+    herr_t ret_value = SUCCEED; /* Return value */
+
+    FUNC_ENTER_PACKAGE
+
+    /* check arguments */
+    assert(f);
+    assert(heap);
+    assert(lnk && lnk->name);
+
+    /* Reset the new entry */
+    H5G__ent_reset(ent);
+
+    /* Add the new name to the heap */
+    if (H5HL_insert(f, heap, strlen(lnk->name) + 1, lnk->name, &name_offset) < 0)
+        HGOTO_ERROR(H5E_SYM, H5E_CANTINSERT, FAIL, "unable to insert symbol name into heap");
+    ent->name_off = name_offset;
+
+    /* Build correct information for symbol table entry based on link type */
+    switch (lnk->type) {
+        case H5L_TYPE_HARD:
+            if (obj_type == H5O_TYPE_GROUP) {
+                const H5G_obj_create_t *gcrt_info = (const H5G_obj_create_t *)crt_info;
+
+                ent->type = gcrt_info->cache_type;
+                if (ent->type != H5G_NOTHING_CACHED)
+                    ent->cache = gcrt_info->cache;
+#ifndef NDEBUG
+                else {
+                    /* Make sure there is no stab message in the target object
+                     */
+                    H5O_loc_t targ_oloc;   /* Location of link target */
+                    htri_t    stab_exists; /* Whether the target symbol table exists */
+
+                    /* Build target object location */
+                    if (H5O_loc_reset(&targ_oloc) < 0)
+                        HGOTO_ERROR(H5E_SYM, H5E_CANTRESET, FAIL, "unable to initialize target location");
+                    targ_oloc.file = f;
+                    targ_oloc.addr = lnk->u.hard.addr;
+
+                    /* Check if a symbol table message exists */
+                    if ((stab_exists = H5O_msg_exists(&targ_oloc, H5O_STAB_ID)) < 0)
+                        HGOTO_ERROR(H5E_SYM, H5E_NOTFOUND, FAIL, "unable to check for STAB message");
+
+                    assert(!stab_exists);
+                } /* end else */
+#endif            /* NDEBUG */
+            }     /* end if */
+            else if (obj_type == H5O_TYPE_UNKNOWN) {
+                /* Try to retrieve symbol table information for caching */
+                H5O_loc_t  targ_oloc;   /* Location of link target */
+                H5O_t     *oh;          /* Link target object header */
+                H5O_stab_t stab;        /* Link target symbol table */
+                htri_t     stab_exists; /* Whether the target symbol table exists */
+
+                /* Build target object location */
+                if (H5O_loc_reset(&targ_oloc) < 0)
+                    HGOTO_ERROR(H5E_SYM, H5E_CANTRESET, FAIL, "unable to initialize target location");
+                targ_oloc.file = f;
+                targ_oloc.addr = lnk->u.hard.addr;
+
+                /* Get the object header */
+                if (NULL == (oh = H5O_protect(&targ_oloc, H5AC__READ_ONLY_FLAG, false)))
+                    HGOTO_ERROR(H5E_SYM, H5E_CANTPROTECT, FAIL, "unable to protect target object header");
+
+                /* Check if a symbol table message exists */
+                if ((stab_exists = H5O_msg_exists_oh(oh, H5O_STAB_ID)) < 0) {
+                    if (H5O_unprotect(&targ_oloc, oh, H5AC__NO_FLAGS_SET) < 0)
+                        HERROR(H5E_SYM, H5E_CANTUNPROTECT, "unable to release object header");
+                    HGOTO_ERROR(H5E_SYM, H5E_NOTFOUND, FAIL, "unable to check for STAB message");
+                } /* end if */
+
+                if (stab_exists) {
+                    /* Read symbol table message */
+                    if (NULL == H5O_msg_read_oh(f, oh, H5O_STAB_ID, &stab)) {
+                        if (H5O_unprotect(&targ_oloc, oh, H5AC__NO_FLAGS_SET) < 0)
+                            HERROR(H5E_SYM, H5E_CANTUNPROTECT, "unable to release object header");
+                        HGOTO_ERROR(H5E_SYM, H5E_CANTGET, FAIL, "unable to read STAB message");
+                    } /* end if */
+
+                    /* Cache symbol table message */
+                    ent->type                  = H5G_CACHED_STAB;
+                    ent->cache.stab.btree_addr = stab.btree_addr;
+                    ent->cache.stab.heap_addr  = stab.heap_addr;
+                } /* end if */
+                else
+                    /* No symbol table message, don't cache anything */
+                    ent->type = H5G_NOTHING_CACHED;
+
+                if (H5O_unprotect(&targ_oloc, oh, H5AC__NO_FLAGS_SET) < 0)
+                    HGOTO_ERROR(H5E_SYM, H5E_CANTUNPROTECT, FAIL, "unable to release object header");
+            } /* end else */
+            else
+                ent->type = H5G_NOTHING_CACHED;
+
+            ent->header = lnk->u.hard.addr;
+            break;
+
+        case H5L_TYPE_SOFT: {
+            size_t lnk_offset; /* Offset to sym-link value	*/
+
+            /* Insert link value into local heap */
+            if (H5HL_insert(f, heap, strlen(lnk->u.soft.name) + 1, lnk->u.soft.name, &lnk_offset) < 0)
+                HGOTO_ERROR(H5E_SYM, H5E_CANTINIT, FAIL, "unable to write link value to local heap");
+
+            ent->type                    = H5G_CACHED_SLINK;
+            ent->cache.slink.lval_offset = lnk_offset;
+        } break;
+
+        case H5L_TYPE_ERROR:
+        case H5L_TYPE_EXTERNAL:
+        case H5L_TYPE_MAX:
+        default:
+            HGOTO_ERROR(H5E_SYM, H5E_BADVALUE, FAIL, "unrecognized link type");
+    } /* end switch */
+
+done:
+    FUNC_LEAVE_NOAPI(ret_value)
+} /* end H5G__link_to_ent() */
+
 /*-------------------------------------------------------------------------
  * Function:	H5G__link_to_loc
  *
diff --git a/src/H5Gloc.c b/src/H5Gloc.c
index 84e8fffa93..f2001cdede 100644
--- a/src/H5Gloc.c
+++ b/src/H5Gloc.c
@@ -539,7 +539,7 @@ H5G__loc_insert(H5G_loc_t *grp_loc, char *name, H5G_loc_t *obj_loc, H5O_type_t o
     lnk.u.hard.addr  = obj_loc->oloc->addr;
 
     /* Insert new group into current group's symbol table */
-    if (H5G_obj_insert(grp_loc->oloc, name, &lnk, TRUE, obj_type, crt_info) < 0)
+    if (H5G_obj_insert(grp_loc->oloc, &lnk, true, obj_type, crt_info) < 0)
         HGOTO_ERROR(H5E_SYM, H5E_CANTINSERT, FAIL, "unable to insert object")
 
     /* Set the name of the object location */
@@ -626,6 +626,68 @@ done:
     FUNC_LEAVE_NOAPI(ret_value)
 } /* end H5G_loc_exists() */
 
+/*-------------------------------------------------------------------------
+ * Function:    H5G__loc_addr_cb
+ *
+ * Purpose:     Callback for retrieving the address for an object in a group
+ *
+ * Return:      Non-negative on success/Negative on failure
+ *
+ *-------------------------------------------------------------------------
+ */
+static herr_t
+H5G__loc_addr_cb(H5G_loc_t H5_ATTR_UNUSED *grp_loc /*in*/, const char H5_ATTR_UNUSED *name,
+                 const H5O_link_t H5_ATTR_UNUSED *lnk, H5G_loc_t *obj_loc, void *_udata /*in,out*/,
+                 H5G_own_loc_t *own_loc /*out*/)
+{
+    haddr_t *udata = (haddr_t *)_udata; /* User data passed in */
+
+    FUNC_ENTER_PACKAGE_NOERR
+
+    /* Check if the name in this group resolved to a valid link */
+    if (obj_loc == NULL)
+        *udata = HADDR_UNDEF; /* No object found */
+    else
+        *udata = obj_loc->oloc->addr; /* Set address of object */
+
+    /* Indicate that this callback didn't take ownership of the group *
+     * location for the object */
+    *own_loc = H5G_OWN_NONE;
+
+    FUNC_LEAVE_NOAPI(SUCCEED)
+} /* end H5G__loc_addr_cb() */
+
+/*-------------------------------------------------------------------------
+ * Function:    H5G__loc_addr
+ *
+ * Purpose:     Retrieve the information for an object from a group location
+ *              and path to that object
+ *
+ * Return:      Non-negative on success/Negative on failure
+ *
+ *-------------------------------------------------------------------------
+ */
+herr_t
+H5G__loc_addr(const H5G_loc_t *loc, const char *name, haddr_t *addr /*out*/)
+{
+    herr_t ret_value = SUCCEED; /* Return value */
+
+    FUNC_ENTER_PACKAGE
+
+    /* Check args. */
+    assert(loc);
+    assert(name && *name);
+    assert(addr);
+
+    /* Traverse group hierarchy to locate object */
+    if (H5G_traverse(loc, name, H5G_TARGET_NORMAL, H5G__loc_addr_cb, addr) < 0)
+        HGOTO_ERROR(H5E_SYM, H5E_NOTFOUND, FAIL, "can't find object");
+
+done:
+    FUNC_LEAVE_NOAPI(ret_value)
+} /* end H5G__loc_addr() */
+
+
 /*-------------------------------------------------------------------------
  * Function:    H5G__loc_info_cb
  *
